module Mail                                                                                                                                            
  module Gpg                                                                                                                                           
    class EncryptedPart < Mail::Part                                                                                                                   
      alias_method :initialize_mailgpg, :initialize

      def initialize(cleartext_mail, options = {})
        if cleartext_mail.protected_headers_subject
          cleartext_mail.content_type_parameters['protected-headers'] = 'v1'                                                                       
        end
        
        # The original "mail-gpg" gem does not handle the smtp envelope correctly
        # as it always sets the envelope "RCPT TO" to all addresses from the To, CC and BCC header.
        # This overwrites the recipients used by "mail-gpg" to the envelope To.
        if cleartext_mail.smtp_envelope_to
          options[:recipients] = cleartext_mail.smtp_envelope_to
        end
        
        initialize_mailgpg(cleartext_mail, options)
      end
    end
  end
end
